# PyCharm
### Настройки интерфейса
Несмотря на то, что разработчики из JetBrains начинали свой путь в России, смена языка интерфейса в среде разработки не предусмотрена, поэтому к вашим услугам будет лишь родной язык Уильяма Шекспира.

Зато вы можете изменить сами шрифты и их размеры, пройдя по пути:

```python
File -> Settings -> editor -> font
```

Поменять цветовую схему UI:

```python
File -> Settings -> editor -> color scheme
```

И сконфигурировать множество других аспектов, вроде общих настроек, конфигураций прокрутки, настроек цвета для каждого доступного языка и так далее. Для всего этого есть редактор:

```python
file -> settings -> editor
```

![Общие настройки редактора находятся в file -> settings -> editor](https://pythonchik.ru/pic/lb1/intext_381cc634-f32c-4d39-bacd-31c1747b89c3_big.webp)

Общие настройки редактора находятся в file -> settings -> editor

### Настройка интерпретатора
Скачать интерпретатор вы можете с [официального сайта Python](https://www.python.org/downloads/). Если в ваши планы не входит работа с библиотеками, которые есть только во второй версии языка, то стоит качать последний релиз Python 3.

О том, как установить Python:

Для использования установленного интерпретатора, выберите его в настройках:

```python
File -> Settings -> Project:<name> -> Project Interpreter
```

![Настройка интерпретатора в Pycharm (file -> settings -> Project:<name> -> Project Interpreter)](https://pythonchik.ru/pic/lb1/intext_95a90af8-bf24-43f9-8aa3-395024658ca5_big.webp)

Настройка интерпретатора в Pycharm (file -> settings -> Project:<name> -> Project Interpreter)

💭 Если PyСharm не видит интерпретатор, попробуйте добавить его вручную. Для этого:

1.  Нажмите на шестеренку в верхнем правом углу, выберите "Add..".
2.  Далее выберите "System Interpreter";
3.  Нажмите на 3 точки "..." справа от поля в выбором интерпретатора;
4.  Укажите путь до интерпретатора.

![Добавление вручную нового интерпретатора в PyCharm ](https://pythonchik.ru/pic/lb1/intext_249a53f1-2289-46c9-9373-b9c345048b6e_big.webp)

Добавление вручную нового интерпретатора в PyCharm

### Настройка виртуального окружения

Если по долгу программистской службы вам приходится работать с несколькими проектами, то определенно не помешает настройка и подключение виртуального окружения.

Venv — это, грубо говоря, директория, содержащая ссылку на интерпретатор и набор установленных библиотек. Виртуальное окружение “изолирует” ваши проекты, и помогает, в частности, не запутаться в разных версиях библиотек, адаптированных для каждого из них по отдельности.

Если вы настроили виртуальное окружение заранее, PyCharm покажет уведомление, в котором предложит использовать его в проекте. Если уведомления нет, вы всегда можете настроить и изменить его вручную в настройках:

```python
File -> Settings -> Project:<name> -> Project Interpreter
```
Также в этом меню можно создать виртуальные окружения с нуля. 
Окружение Pipenv создается аналогичным образом

Есть еще один способ запуска кода:

-   Внизу окна программы кликните на "Terminal".
-   Напишите в терминале `python <name>.py` или `python3 <name>.py`.

![Альтернативный вариант запуска Python-кода — через встроенный терминал.](https://pythonchik.ru/pic/lb1/intext_96439b93-6522-4e80-822b-baf62d2715f6_big.webp)

PyCharm умеет запускать Python-код в интерактивном режиме

## Отладчик (debugger) в Pycharm

Отладка — чрезвычайно полезный инструмент. С помощью него можно пошагово исполнять программный код. Интерпретатор переходит в особый режим, фиксируя на каждом этапе выполнения текущее состояние программы. Т.е. для каждой строки кода вам будет представлен мини-отчёт.

```python
чтобы выполнить нужно использовать Shift + F9
```
![Запустив код в режиме отладки, откроется окно "Debug" с информацией о ходе выполнения и текущем состоянии.](https://pythonchik.ru/pic/lb1/intext_ffb72919-ccea-4335-b235-519bb2408271_big.webp)

Нажимая `F8`, "Шагаем без захода",  а `F7`,  "Шаг с заходом". 

![Кнопки навигации в режиме отладки в PyCharm](https://pythonchik.ru/pic/lb1/intext_beba507f-1cab-4c30-97f8-4879d2e272d0_big.webp)
Для каждой кнопки существует свой hotkey.



## Макросы



Чтобы создать или настроить свой собственный макрос, вам нужно выбрать:
```python
Edit -> Macros -> Start Macro Recording
```
После записи макроса, нажмите `Stop Macro Recording`.

## Полезные хоткеи и фишки

Изменение цвета консоли в pycharm. Поменять цвет консольного бэкграунда или шрифтов нужно для зайти в настройки цветовой схемы.
```python
File -> Settings -> Editor -> Color Scheme
```
Поиск по всему проекту осуществляется.

-   Для поиска по коду во всем проекта, выполните комбинацию `Ctrl + Shift + F`.
-   Для поиска всего и вся во всём проекте дважды нажимаем клавишу `Shift`.

 С помощью комбинации клавиш `Shift + F10` можно запустить ваш проект, а нажав `Shift + F9` — начать его отладку.

Закомментировать сразу несколько строк. Вы мышкой выделяете нужные строки, а затем нажимаете `Ctrl + /`.

Повторив то же самое действие на том же самом месте, вы выполните раскомментирование кода.

-   Отступ — `Tab`.
-   Для нескольких строк выделите нужные строки и нажмите `Tab`.
-   Для обратного отступа (отступа в левую сторону) — `Shift + Tab`.

Пример горячих клавиш.

-   `Ctrl + Alt + L` — автоформатирование кода по PEP 8.
-   `Ctr + Z` — отмена последнего выполненного действия.
-   `Ctr + Up/Down` — прокрутка без изменения позиции курсора.
-   `Ctr + D` — дублировать строку.
-   `Tab / Shift + Tab` — увеличить / уменьшить отступ.
-   `Ctr + Space` — выводит предложения по автозаполнению.

## Полезные плагины для Pycharm

Меню установки плагинов находится в:

```python
File -> Settings -> Plugins
```

Для установки плагина достаточно написать его название в строке поиска, найти плагин и нажать "Install".

⭐ Вот список полезных плагинов, которые стоит установить:

-   Highlight Bracket Pair  — плагин позволяет не запутаться в излюбленном занятии программистов — поиске соответствия между открывающими и закрывающими скобками.
-   Grep Console — расширение функционала стандартной консоли PyCharm — изменение цвета для разного типа сообщений, вкладки в консоли, аналог `grep` для вывода и т.д.
-   Pylint  — Python линтер. После установки появится меню "Pylint" в нижнем левом углу. Для работы плагина необходимо установить модуль [pylint](https://pypi.org/project/pylint/) (`python -m pip install pylint` или `python3 -m pip install pylint`), и в настройках PyCharm указать путь до него (в Windows он обычно лежит в папке `C:\<python_path>\Scripts`, а в Linux путь до pylint можно узнать с помощью `which pylint`).
-   DeepBugs for Python — ищет потенциальные баги и проблемы, связанные с качеством кода используя модели машинного обучения.

Другие полезные плагины:

-   Python Smart Execute — комбинация Alt + Shift + A копирует выделенный код в Python-консоль и выполняет его.
-   MyPy  - плагин для проверки типов (type hinting) и анализатор исходного кода для Python. После установки появится меню "MyPy" в нижнем левом углу.
-   CodeGlance — добавляет мини-карту (minimap) кода в окне редактора справа.

