# Интегрированная среда разработки Visual Studio
(IDE) — это многофункциональная программа, которая поддерживает многие аспекты разработки программного обеспечения. Интегрированная среда разработки Visual Studio — это стартовая площадка для написания, отладки и сборки кода, а также последующей публикации приложений.

## Возможности Visual Studio

### Модульная установка

Модульный установщик Visual Studio позволяет выбирать и устанавливать требуемые рабочие нагрузки. Рабочие нагрузки — это группы функций, которые должны работать в языках программирования или платформах. Такая модульная стратегия сокращает объем установки Visual Studio, ускоряя установку и обновление среды.

Установите Visual Studio бесплатно со страницы скачиваемых материалов Visual Studio, если еще не сделали этого.

### Создание приложений Azure с поддержкой облака

Visual Studio предлагает набор инструментов, которые позволяют без усилий создавать облачные приложения на базе Microsoft Azure. Вы можете настраивать, создавать, отлаживать, упаковывать и развертывать приложения и службы Azure непосредственно из интегрированной среды разработки (IDE) Visual Studio. Чтобы получить инструменты Azure и шаблоны проектов, при установке Visual Studio выберите рабочую нагрузку Разработка для Azure.

![Alt-текст](https://learn.microsoft.com/ru-ru/visualstudio/ide/media/vs-2022/azure-development-workload.png?view=vs-2022 "Azure")

Вы можете использовать службы Azure для приложений с помощью Подключенных служб:

+ Подключенная служба Active Directory позволяет использовать учетные записи Azure Active Directory для подключения к веб-приложениям.
+ Подключенная служба хранилища Azure — хранилище больших двоичных объектов, очереди и таблицы.
+ Подключенная служба Key Vault служит для управления секретами для веб-приложений.

Доступные Подключенные службы зависят от типа проекта. Добавьте службу, щелкнув проект в Обозревателе решений правой кнопкой мыши и выбрав Добавить>Подключенная служба.

На экране Подключенные службы выберите ссылку или знак "+", чтобы добавить зависимость службы. На экране Добавление зависимости выберите службу, которую нужно добавить, и следуйте инструкциям, чтобы подключиться к подписке и службе Azure.

![Alt-текст](https://learn.microsoft.com/ru-ru/visualstudio/ide/media/vs-2022/connected-services.png?view=vs-2022 "Azure1")

### Создание веб-приложений

Visual Studio помогает создавать приложения для Интернета. Вы можете создавать веб-приложения с помощью ASP.NET, Node.js, Python, JavaScript и TypeScript. Visual Studio поддерживает множество веб-платформ, таких как Angular, jQuery и Express.

Платформы ASP.NET Core и .NET Core поддерживаются на компьютерах с Windows и Linux, а также на компьютерах Mac. ASP.NET Core — это основное обновление для MVC, WebAPI и SignalR. Разработанная с нуля платформа ASP.NET Core предоставляет компактный и изменяемый стек .NET для разработки современных облачных веб-приложений и служб.


### Создание кроссплатформенных приложений и игр

С помощью Visual Studio вы можете создавать приложения и игры для macOS, Linux и Windows, а также для мобильных устройств Android, iOS и пр. С помощью Visual Studio вы можете выполнять сборку:

+ приложений .NET Core для использования на устройствах Windows, macOS и Linux;

+ мобильных приложений для устройств iOS, Android и Windows на C# и F# с помощью Xamarin;

+ двух- и трехмерных игр на C# с помощью Инструментов Visual Studio для Unity;

+ собственных приложений C++ для устройств iOS, Android и Windows. Предоставляйте доступ к общему коду в библиотеках для iOS, Android и Windows с помощью C++ для кроссплатформенной разработки.

### Подключение к базам данных

Обозреватель сервера позволяет просматривать и администрировать экземпляры и ресурсы сервера в локальной и удаленной средах, Azure, Salesforce.com, Microsoft 365 и на веб-сайтах. Чтобы открыть обозреватель сервера, выберите Вид>Обозреватель сервера. Дополнительные сведения об использовании обозревателя серверов см. в статье Добавление новых подключений.

Обозреватель объектов SQL Server позволяет просматривать объекты баз данных так же, как и в среде SQL Server Management Studio. Обозреватель объектов SQL Server позволяет выполнять простые действия для администрирования и проектирования баз данных. Примеры включают редактирование данных в таблицах, сравнение схем и выполнение запросов с помощью контекстных меню.

Чтобы открыть SQL Server обозреватель объектов, щелкните его значок в верхней части окна обозревателя сервера или выберите пункт "Вид>SQL Server обозреватель объектов в верхнем меню Visual Studio.

![Alt-текст](https://learn.microsoft.com/ru-ru/visualstudio/ide/media/vs-2022/sql-server-object-explorer.png?view=vs-2022 "Sql")

**SQL Server Data Tools (SSDT)** — это мощная среда разработки для SQL Server, базы данных SQL Azure и хранилища данных SQL Azure. С помощью SSDT вы можете создавать, отлаживать и обслуживать базы данных, а также выполнять их рефакторинг. Можно работать с проектом базы данных или напрямую с подключенным экземпляром базы данных (локально или удаленно). Чтобы получить SSDT, используйте Visual Studio Installer для установки рабочей нагрузки Хранение и обработка данных.

### Отладка, тестирование и совершенствование кода

Когда вы пишете код, вы должны запустить и протестировать его на предмет ошибок и производительности. Система отладки Visual Studio позволяет отлаживать код в локальном проекте, на удаленном устройстве или в эмуляторе устройства. Вы можете просматривать код с шагом в один оператор, проверяя значения переменных. Или вы можете задать точки останова, которые срабатывают только при выполнении указанного условия. Параметрами отладки можно управлять в самом редакторе кода, не выходя из окна с кодом.

Чтобы повысить производительность приложения, ознакомьтесь с функцией профилирования в Visual Studio.

Для тестирования в Visual Studio предусмотрены такие возможности, как модульное тестирование, Live Unit Testing, IntelliTest, а также тестирование производительности и нагрузочное тестирование. Visual Studio также предоставляет расширенные возможности анализа кода для выявления ошибок конструктора, проблем с безопасностью и прочих дефектов.

### Развертывание готового приложения

Visual Studio содержит средства для развертывания приложения для пользователей или клиентов с помощью Microsoft Store, сайта SharePoint, InstallShield или установщика Windows. Доступ ко всем этим вариантам можно получить через Visual Studio IDE. Дополнительные сведения см. в статье Общие сведения о развертывании в Visual Studio.

### Управление исходным кодом и совместная работа

В Visual Studio вы можете управлять исходным кодом в репозиториях Git, размещенных любым поставщиком, включая GitHub. Также вы можете здесь найти сервер Azure DevOps Server для подключения.

## Хитрости для работы с Visual Studio

### Отладчик

Использование F10 вместо F5 для сборки, запуска и присоединения отладчика автоматически прерывается при первом выполнении вашего собственного кода. В точках останова нет необходимости.

![Alt-текст](https://hsto.org/webt/9n/qn/nn/9nqnnnvcghft4ogcwl7ile7m84g.gif "Отладчик")

Поддерживается начиная с Visual Studio 2005


**Reattach to process** (Shift+Alt+P) чрезвычайно полезная функция, которая помогает снова и снова присоединяться к одному и тому же процессу.

![Alt-текст](https://hsto.org/r/w1560/webt/zx/qg/fm/zxqgfmsum5dm-levhzmhpjh2a34.png "Отладчик2")

Поддерживается начиная с Visual Studio 2017 v15.8


### Solution

Повысьте производительность загрузки решения и уменьшите визуальный шум, отключив восстановление расширений узлов в Solution Explorer, а также Reopen documents on solution load.

![Alt-текст](https://hsto.org/r/w1560/webt/j7/ru/nd/j7rundgqwmstan4dukweqabdgps.jpeg "Solution")

Поддерживается начиная с Visual Studio 2019

Для быстрой навигации используйте **Ctrl+T**, чтобы найти что-либо в вашем решении — файлы, классы и т. д.

![Alt-текст](https://hsto.org/r/w1560/webt/k6/qw/uy/k6qwuyjan8shjx4vchudrtwh1zk.jpeg "Solution2")

Поддерживается начиная с Visual Studio 2017

**Назначьте сочетание клавиш для выполнения “git pull”**, чтобы не приходилось использовать для этого CLI или Team Explorer.

![Alt-текст](https://hsto.org/r/w1560/webt/yz/y8/c6/yzy8c65ocupn2legjnl5zhrijdg.png "Solution3")

Поддерживается начиная с Visual Studio 2019

**Дайте Solution Explorer возможность автоматически выбирать текущий активный документ**, чтобы никогда не терять его расположение в проекте.

![Alt-текст](https://hsto.org/r/w1560/webt/7k/sq/jj/7ksqjjnav4rh2crx7zer4bipkoq.jpeg "Solution4")

Поддерживается начиная с Visual Studio 2010


### Редактор

Легко **выделяйте HTML-элементы** тегом div, используя комбинацию Shift+Alt+W. Вставленный div вы можете легко отредактировать на любой тег, который вы хотите, и закрывающий тег изменится автоматически.

![Alt-текст](https://habrastorage.org/r/w1560/webt/pv/yd/re/pvydre8zbbna64i41xavnywfvmu.jpeg "Редактор")

Поддерживается начиная с Visual Studio 2017

**Скопируйте любой фрагмент JSON** в буфер обмена и вставьте его как строго типизированные классы .NET в любой файл C# или VB.

![Alt-текст](https://habrastorage.org/r/w1560/webt/ee/9l/wo/ee9lwoigdmirfoe4pxsyqlwpcsq.jpeg "Редактор2")

Поддерживается начиная с Visual Studio 2013

**Вам не нужно самостоятельно ставить двойные кавычки** вокруг имен свойств JSON — просто введите двоеточие, и Visual Studio автоматически поставит их.

![Alt-текст](https://habrastorage.org/webt/hk/wj/rz/hkwjrzoy0-gsmjreyup6ngeqafe.gif "Редактор3")

Поддерживается начиная с Visual Studio 2015

**Сделайте IntelliSense и всплывающие подсказки полупрозрачными** на время нажатия и удержания Control.

![Alt-текст](https://habrastorage.org/r/w1560/webt/6q/of/pr/6qofprxhfzosql2wp_7pner8-t4.jpeg "Редактор4")

Поддерживается начиная с Visual Studio 2010

**Вместо повторного ввода ‘(‘** для отображения информации о параметрах в сигнатурах методов используйте Ctrl+Shift+Space для отображения используемой в данный момент перегрузки.

![Alt-текст](https://habrastorage.org/r/w1560/webt/kc/1h/jx/kc1hjxjb5bys45vohtyxrewlxr0.jpeg "Редактор5")

Поддерживается начиная с Visual Studio 2010





